﻿
namespace TextCompare
{
    interface ITextMatcher
    {
        /// <summary>
        /// The source string
        /// </summary>
        string Source { get; }

        /// <summary>
        /// The target string
        /// </summary>
        string Target { get;}

        /// <summary>
        /// The count of source string.
        /// </summary>
        int SourceCount { get; }

        /// <summary>
        /// The count of target string.
        /// </summary>
        int TargetCount { get; }

        /// <summary>
        /// Compare position in source and target
        /// </summary>
        /// <param name="i">position in source</param>
        /// <param name="j">position in target</param>
        /// <returns></returns>
        bool Compare(int i, int j);

        string GetSourceSubString(int startPoint, int endPoint);

        string GetTargetSubString(int startPoint, int endPoint);
    }
}
